searchNodes=[{"type":"module","title":"Peep","doc":"Telemetry.Metrics reporter supporting Statsd and Prometheus. To use it, start the reporter with start_link/1 , providing a list of Telemetry.Metrics metric definitions in a Keyword list matching the schema specified in Peep.Options : import Telemetry.Metrics Peep . start_link ( [ name : :my_peep , metrics : [ counter ( &quot;http.request.count&quot; ) , sum ( &quot;http.request.payload_size&quot; ) , last_value ( &quot;vm.memory.total&quot; ) , distribution ( &quot;http.request.latency&quot; ) ] ] ) To emit Statsd metrics, Peep supports both UDP and Unix Domain Sockets. Why another Telemetry.Metrics library? Both TelemetryMetricsStatsd and TelemetryMetrics.Prometheus are great choices for emitting telemetry. However, Peep makes several different choices that may not be as general-purpose as either of those libraries. No sampled metrics Sampling is a popular approach to reduce the amount of Statsd data flowing out of a service, but naive sampling dramatically reduces visibility into the shapes of distributions. Peep represents distributions using histograms, using a small exponential function by default. This sacrifices some granularity on individual samples, but one usually doesn't mind too much if a sample value of 95 is rounded to 100 , or if 950 is rounded to 1000 . These histograms are emitted to statsd using the optional sample rate of 1/$count . Peep uses :atomics stored in :ets for performance. New :atomics arrays are created when a metric with a new set of tags is observed, so there is a slight overhead when handling the first telemetry event with a distinct set of tags. Peep reporter processes are not involved in the handling of any :telemetry events, so there's no chance of a single process becoming a bottleneck. Distributions are aggregated immediately This is a consequence of choosing to represent distributions as histograms. There is no step in Peep 's processing where samples are aggregated in large batches. This leads to a flatter performance profile when scaling up. Statsd packets are stuffed This is something that is not (at the time of writing) supported by TelemetryMetricsStatsd , but the need for stuffing packets became pretty clear when handling tens of thousands of telemetry events every second. During each reporting period, metrics collected by a Peep reporter will be collected into a minimum number of packets. Users can set the maximum packet size in Peep.Options .","ref":"Peep.html"},{"type":"function","title":"Peep.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Peep.html#child_spec/1"},{"type":"function","title":"Peep.get_all_metrics/1","doc":"Fetches all metrics from the worker. Called when preparing Prometheus or StatsD data.","ref":"Peep.html#get_all_metrics/1"},{"type":"function","title":"Peep.start_link/1","doc":"","ref":"Peep.html#start_link/1"},{"type":"module","title":"Peep.Options","doc":"Options for a Peep reporter. Validated with NimbleOptions . :name ( atom/0 ) - Required. A name for the Peep worker process :metrics (list of term/0 ) - Required. A list of Telemetry.Metrics metric definitions to be collected and exposed. :statsd - An optional keyword list of statsd configuration. :flush_interval_ms ( non_neg_integer/0 ) - Time interval between StatsD metric emissions. The default value is 5000 . :host - Hostname or IP address of the StatsD server. The default value is {127, 0, 0, 1} . :port ( non_neg_integer/0 ) - Port of the StatsD server. The default value is 8125 . :socket_path - Path to the Unix Domain Socket used for publishing instead of the hostname and port. Overrides :host and :port configuration if present :formatter - Determines the format of the published metrics. Can be either :standard or :datadog . The default value is :standard . :mtu ( non_neg_integer/0 ) - Determine max size of statsd packets. For UDP, 1472 is a good choice. For UDS, 8192 is probably better. The rationale for these recommendations comes from this guide . The default value is 1472 . :global_tags ( keyword/0 ) - Additional tags published with every metric. Global tags are overriden by the tags specified in the metric definition. The default value is [] .","ref":"Peep.Options.html"},{"type":"function","title":"Peep.Options.docs/0","doc":"","ref":"Peep.Options.html#docs/0"},{"type":"function","title":"Peep.Options.validate/1","doc":"","ref":"Peep.Options.html#validate/1"},{"type":"module","title":"Peep.Prometheus","doc":"Prometheus exporter module. If your application handles calls to &quot;GET /metrics&quot;, your handler can call: Peep . get_all_metrics ( :my_peep ) # Replace with your Peep reporter name |&gt; Peep.Prometheus . export ( )","ref":"Peep.Prometheus.html"},{"type":"function","title":"Peep.Prometheus.export/1","doc":"","ref":"Peep.Prometheus.html#export/1"},{"type":"module","title":"Peep.Telemetry","doc":":telemetry events for Peep itself. Telemetry events [:peep, :packet, :sent] . Metadata contains %{size: packet_size} [:peep, :packet, :error] . Metadata contains %{reason: reason}","ref":"Peep.Telemetry.html"},{"type":"function","title":"Peep.Telemetry.sent_packet/2","doc":"","ref":"Peep.Telemetry.html#sent_packet/2"},{"type":"behaviour","title":"Peep.Buckets","doc":"A behavior for histogram bucketing strategies. If no bucketing strategy is provided (i.e. peep_bucket_calculator is not set in :reporter_options for a %Telemetry.Metrics.Distribution{} , then the default is Elixir.Peep.Buckets.Exponential . If you want custom bucket boundaries, there is Peep.Buckets.Custom , which uses pattern matching to assign sample measurements to buckets.","ref":"Peep.Buckets.html"},{"type":"callback","title":"Peep.Buckets.bucket_for/2","doc":"","ref":"Peep.Buckets.html#c:bucket_for/2"},{"type":"function","title":"Peep.Buckets.config/1","doc":"","ref":"Peep.Buckets.html#config/1"},{"type":"callback","title":"Peep.Buckets.config/1","doc":"","ref":"Peep.Buckets.html#c:config/1"},{"type":"callback","title":"Peep.Buckets.number_of_buckets/1","doc":"","ref":"Peep.Buckets.html#c:number_of_buckets/1"},{"type":"callback","title":"Peep.Buckets.upper_bound/2","doc":"","ref":"Peep.Buckets.html#c:upper_bound/2"},{"type":"type","title":"Peep.Buckets.config/0","doc":"","ref":"Peep.Buckets.html#t:config/0"},{"type":"module","title":"Peep.Buckets.Custom","doc":"A helper module for writing modules that implement the Peep.Buckets behavior, with custom bucket boundaries. For an example, look at the source of Peep.Buckets.PowersOfTen .","ref":"Peep.Buckets.Custom.html"},{"type":"module","title":"Peep.Buckets.Exponential","doc":"The default bucketing strategy in Peep, based on the logarithmic bucketing scheme in the DDSketch paper. This bucketing scheme takes two parameters: max_value - a maximum expected value. Defaults to 1000000000. bucket_variability - a percentage reflecting roughly half the amount by which bucket ranges should grow. Defaults to 0.1.","ref":"Peep.Buckets.Exponential.html"},{"type":"module","title":"Peep.Buckets.PowersOfTen","doc":"An implementation of Peep.Buckets , using Peep.Buckets.Custom .","ref":"Peep.Buckets.PowersOfTen.html"}]